Index: librt/primitives/extrude/extrude.c
===================================================================
--- librt/primitives/extrude/extrude.c	(revision 54048)
+++ librt/primitives/extrude/extrude.c	(working copy)
@@ -313,9 +313,9 @@
     }
 
     if (extr->verts)
-	 bu_free((char *)extr->verts, "extrude->verts");
+	 bu_free((genptr_t)extr->verts, "extrude->verts");
     rt_curve_free(&(extr->crv));
-    bu_free((char *)extr, "extrude_specific");
+    bu_free((genptr_t)extr, "extrude_specific");
 
     return 0;              /* OK */
 }
@@ -979,10 +979,10 @@
 			V2SUB2(to_pt, intercept[j], ray_start);
 			dists[j] = V2DOT(to_pt, ray_dir_unit) / diff;
 		    }
-		    bu_free((char *)intercept, "Bezier intercept");
+		    bu_free((genptr_t)intercept, "Bezier intercept");
 		    surfno = BEZIER_SEG;
 		}
-		bu_free((char *)verts, "Bezier verts");
+		bu_free((genptr_t)verts, "Bezier verts");
 		break;
 	    case CURVE_NURB_MAGIC:
 		break;
@@ -1115,7 +1115,7 @@
 	    hit_count++;
 	}
 	if (free_dists)
-	    bu_free((char *)dists, "dists");
+	    bu_free((genptr_t)dists, "dists");
     }
 
     if (check_inout) {
@@ -1338,9 +1338,9 @@
 	(struct extrude_specific *)stp->st_specific;
 
     if (extrude->verts)
-	bu_free((char *)extrude->verts, "extrude->verts");
+	bu_free((genptr_t)extrude->verts, "extrude->verts");
     rt_curve_free(&(extrude->crv));
-    bu_free((char *)extrude, "extrude_specific");
+    bu_free((genptr_t)extrude, "extrude_specific");
 }
 
 
@@ -1599,7 +1599,7 @@
 	    } else {
 		V2MOVE(pt, tmp_pt);
 	    }
-	    bu_free((char *)eg.ctl_points, "eg.ctl_points");
+	    bu_free((genptr_t)eg.ctl_points, "eg.ctl_points");
 	    break;
 	case CURVE_BEZIER_MAGIC:
 	    bsg = (struct bezier_seg *)lng;
@@ -1608,7 +1608,7 @@
 		VMOVE_2D(V[i], skt->verts[bsg->ctl_points[i]]);
 	    }
 	    Bezier(V, bsg->degree, 0.51, NULL, NULL, pt, NULL);
-	    bu_free((char *)V, "Bezier control points");
+	    bu_free((genptr_t)V, "Bezier control points");
 	    break;
 	default:
 	    bu_bomb("Unrecognized segment type in sketch\n");
@@ -1849,10 +1849,10 @@
 		    }
 		}
 		if ((*intercept))
-		    bu_free((char *)intercept, "Bezier Intercepts");
+		    bu_free((genptr_t)intercept, "Bezier Intercepts");
 		if ((*normal))
-		    bu_free((char *)normal, "Bezier normals");
-		bu_free((char *)verts, "Bezier Ctl points");
+		    bu_free((genptr_t)normal, "Bezier normals");
+		bu_free((genptr_t)verts, "Bezier Ctl points");
 		break;
 	    default:
 		bu_log("isect_2D_loop_ray: Unrecognized curve segment type x%x\n", *lng);
@@ -1877,7 +1877,7 @@
 	ptr = ptr->next;
 	if (ptr->vert_index > -1 && ptr->vert_index == prev->vert_index) {
 	    prev->next = ptr->next;
-	    bu_free((char *)ptr, "struct loop_inter");
+	    bu_free((genptr_t)ptr, "struct loop_inter");
 	    ptr = prev;
 	}
     }
@@ -1889,7 +1889,7 @@
 	diff = fabs(ptr->dist - prev->dist);
 	if (diff < tol->dist) {
 	    prev->next = ptr->next;
-	    bu_free((char *)ptr, "struct loop_inter");
+	    bu_free((genptr_t)ptr, "struct loop_inter");
 	    ptr = prev;
 	}
     }
@@ -1984,7 +1984,7 @@
 	    }
 	}
 	ptr = ptr->next;
-	bu_free((char *)tmp, "loop intercept");
+	bu_free((genptr_t)tmp, "loop intercept");
     }
 
     return ret;
@@ -2077,16 +2077,16 @@
 		for (j=0; j<(size_t)BU_PTBL_END(&loops); j++) {
 		    aloop = (struct bu_ptbl *)BU_PTBL_GET(&loops, j);
 		    bu_ptbl_free(aloop);
-		    bu_free((char *)aloop, "aloop");
+		    bu_free((genptr_t)aloop, "aloop");
 		}
 		bu_ptbl_free(&loops);
-		bu_free((char *)used_seg, "used_seg");
+		bu_free((genptr_t)used_seg, "used_seg");
 		return -2;
 	    }
 	}
 	bu_ptbl_ins(&loops, (long *)aloop);
     }
-    bu_free((char *)used_seg, "used_seg");
+    bu_free((genptr_t)used_seg, "used_seg");
 
     /* sort the loops to find inside/outside relationships */
     containing_loops = (struct bu_ptbl **)bu_calloc(BU_PTBL_END(&loops),
@@ -2137,12 +2137,12 @@
 	for (i=0; i<(size_t)BU_PTBL_END(&loops); i++) {
 	    aloop = (struct bu_ptbl *)BU_PTBL_GET(&loops, i);
 	    bu_ptbl_free(aloop);
-	    bu_free((char *)aloop, "aloop");
+	    bu_free((genptr_t)aloop, "aloop");
 	    bu_ptbl_free(containing_loops[i]);
-	    bu_free((char *)containing_loops[i], "aloop");
+	    bu_free((genptr_t)containing_loops[i], "aloop");
 	}
 	bu_ptbl_free(&loops);
-	bu_free((char *)containing_loops, "containing_loops");
+	bu_free((genptr_t)containing_loops, "containing_loops");
     }
 
     BU_LIST_INIT(&vhead);
@@ -2188,7 +2188,7 @@
     BN_FREE_VLIST(&rt_g.rtg_vlfree, &vhead);
 
     /* make sure face normal is in correct direction */
-    bu_free((char *)verts, "verts");
+    bu_free((genptr_t)verts, "verts");
     if (nmg_calc_face_plane(fu, pl)) {
 	bu_log("Failed to calculate face plane for extrusion\n");
 	return -1;
@@ -2289,11 +2289,11 @@
  failed:
     for (i=0; i<(size_t)BU_PTBL_END(&loops); i++) {
 	bu_ptbl_free(containing_loops[i]);
-	bu_free((char *)containing_loops[i], "containing_loops[i]");
+	bu_free((genptr_t)containing_loops[i], "containing_loops[i]");
     }
-    bu_free((char *)containing_loops, "containing_loops");
+    bu_free((genptr_t)containing_loops, "containing_loops");
     bu_ptbl_free(aloop);
-    bu_free((char *)aloop, "aloop");
+    bu_free((genptr_t)aloop, "aloop");
     return -1;
 }
 
@@ -2600,7 +2600,7 @@
     extrude_ip->magic = 0;	/* sanity */
 
     bu_free(extrude_ip->sketch_name, "Extrude sketch_name");
-    bu_free((char *)extrude_ip, "extrude ifree");
+    bu_free((genptr_t)extrude_ip, "extrude ifree");
     ip->idb_ptr = GENPTR_NULL;	/* sanity */
 }
 
@@ -2771,7 +2771,7 @@
 	    extr->keypoint = atoi(argv[1]);
 	} else if (*argv[0] == 'S') {
 	    if (extr->sketch_name)
-		bu_free((char *)extr->sketch_name, "rt_extrude_tcladjust: sketch_name");
+		bu_free((genptr_t)extr->sketch_name, "rt_extrude_tcladjust: sketch_name");
 	    extr->sketch_name = bu_strdup(argv[1]);
 	}
 
Index: librt/primitives/arbn/arbn.c
===================================================================
--- librt/primitives/arbn/arbn.c	(revision 54048)
+++ librt/primitives/arbn/arbn.c	(working copy)
@@ -184,10 +184,10 @@
 	if (used[i] != 0) continue;	/* face was used */
 	bu_log("arbn(%s) face %zu unused, solid is not convex\n",
 	       stp->st_name, i);
-	bu_free((char *)used, "arbn used[]");
+	bu_free((genptr_t)used, "arbn used[]");
 	return -1;		/* BAD */
     }
-    bu_free((char *)used, "arbn used[]");
+    bu_free((genptr_t)used, "arbn used[]");
 
     stp->st_specific = (genptr_t)aip;
     ip->idb_ptr = GENPTR_NULL;	/* indicate we stole it */
@@ -382,8 +382,8 @@
     struct rt_arbn_internal *aip =
 	(struct rt_arbn_internal *)stp->st_specific;
 
-    bu_free((char *)aip->eqn, "rt_arbn_internal eqn[]");
-    bu_free((char *)aip, "rt_arbn_internal");
+    bu_free((genptr_t)aip->eqn, "rt_arbn_internal eqn[]");
+    bu_free((genptr_t)aip, "rt_arbn_internal");
 }
 
 
@@ -779,24 +779,24 @@
 	nmg_vertex_gv(*pts[i].vp, pts[i].pt);
     }
 
-    bu_free((char *)pts, "rt_arbn_tess: pts");
-    bu_free((char *)edges, "rt_arbn_tess: edges");
-    bu_free((char *)edge_count, "rt_arbn_tess: edge_count");
-    bu_free((char *)verts, "rt_arbn_tess: verts");
-    bu_free((char *)loop_verts, "rt_arbn_tess: loop_verts");
+    bu_free((genptr_t)pts, "rt_arbn_tess: pts");
+    bu_free((genptr_t)edges, "rt_arbn_tess: edges");
+    bu_free((genptr_t)edge_count, "rt_arbn_tess: edge_count");
+    bu_free((genptr_t)verts, "rt_arbn_tess: verts");
+    bu_free((genptr_t)loop_verts, "rt_arbn_tess: loop_verts");
 
     /* Associate face geometry */
     for (i=0; i<face_count; i++) {
 	if (nmg_fu_planeeqn(fu[i], tol)) {
 	    bu_log("Failed to calculate face plane equation\n");
-	    bu_free((char *)fu, "rt_arbn_tess: fu");
+	    bu_free((genptr_t)fu, "rt_arbn_tess: fu");
 	    nmg_kr(*r);
 	    *r = (struct nmgregion *)NULL;
 	    return -1;
 	}
     }
 
-    bu_free((char *)fu, "rt_arbn_tess: fu");
+    bu_free((genptr_t)fu, "rt_arbn_tess: fu");
 
     nmg_fix_normals(s, tol);
 
@@ -808,10 +808,10 @@
     return 0;
 
 fail:
-    bu_free((char *)pts, "rt_arbn_tess: pts");
-    bu_free((char *)edges, "rt_arbn_tess: edges");
-    bu_free((char *)edge_count, "rt_arbn_tess: edge_count");
-    bu_free((char *)verts, "rt_arbn_tess: verts");
+    bu_free((genptr_t)pts, "rt_arbn_tess: pts");
+    bu_free((genptr_t)edges, "rt_arbn_tess: edges");
+    bu_free((genptr_t)edge_count, "rt_arbn_tess: edge_count");
+    bu_free((genptr_t)verts, "rt_arbn_tess: verts");
     return -1;
 }
 
@@ -947,7 +947,7 @@
 
     htond((unsigned char *)&rec[1], (unsigned char *)sbuf, aip->neqn * ELEMENTS_PER_PLANE);
 
-    bu_free((char *)sbuf, "arbn temp");
+    bu_free((genptr_t)sbuf, "arbn temp");
     return 0;			/* OK */
 }
 
@@ -1075,7 +1075,7 @@
     /* Convert from internal (host) to database (network) format */
     htond((unsigned char *)ep->ext_buf + SIZEOF_NETWORK_LONG, (unsigned char *)vec, double_count);
 
-    bu_free((char *)vec, "arbn temp");
+    bu_free((genptr_t)vec, "arbn temp");
     return 0;			/* OK */
 }
 
@@ -1129,8 +1129,8 @@
     RT_ARBN_CK_MAGIC(aip);
 
     if (aip->neqn > 0)
-	bu_free((char *)aip->eqn, "rt_arbn_internal eqn[]");
-    bu_free((char *)aip, "rt_arbn_internal");
+	bu_free((genptr_t)aip->eqn, "rt_arbn_internal eqn[]");
+    bu_free((genptr_t)aip, "rt_arbn_internal");
 
     ip->idb_ptr = (genptr_t)0;	/* sanity */
 }
@@ -1255,11 +1255,11 @@
 		bu_vls_printf(logstr,
 			      "ERROR: Incorrect number of plane coefficients\n");
 		if (len)
-		    bu_free((char *)new_planes, "new_planes");
+		    bu_free((genptr_t)new_planes, "new_planes");
 		return BRLCAD_ERROR;
 	    }
 	    if (arbn->eqn)
-		bu_free((char *)arbn->eqn, "arbn->eqn");
+		bu_free((genptr_t)arbn->eqn, "arbn->eqn");
 	    arbn->eqn = (plane_t *)new_planes;
 	    arbn->neqn = (size_t)len / ELEMENTS_PER_PLANE;
 	    for (i=0; i<arbn->neqn; i++)
Index: librt/primitives/revolve/revolve.c
===================================================================
--- librt/primitives/revolve/revolve.c	(revision 54048)
+++ librt/primitives/revolve/revolve.c	(working copy)
@@ -1183,7 +1183,7 @@
     struct revolve_specific *revolve =
 	(struct revolve_specific *)stp->st_specific;
     bu_free(revolve->ends, "endcount");
-    bu_free((char *)revolve, "revolve_specific");
+    bu_free((genptr_t)revolve, "revolve_specific");
 }
 
 
@@ -1723,7 +1723,7 @@
     else
 	bu_log("Freeing bogus revolve, VLS string not initialized\n");
 
-    bu_free((char *)revolve_ip, "revolve ifree");
+    bu_free((genptr_t)revolve_ip, "revolve ifree");
     ip->idb_ptr = GENPTR_NULL;	/* sanity */
 }
 
Index: librt/primitives/poly/poly.c
===================================================================
--- librt/primitives/poly/poly.c	(revision 54048)
+++ librt/primitives/poly/poly.c	(working copy)
@@ -181,7 +181,7 @@
     m4 = MAGNITUDE(trip->tri_wn);
     if (m1 < tol->dist || m2 < tol->dist ||
 	m3 < tol->dist || m4 < tol->dist) {
-	bu_free((char *)trip, "getstruct tri_specific");
+	bu_free((genptr_t)trip, "getstruct tri_specific");
 	if (RT_G_DEBUG & DEBUG_ARB8)
 	    bu_log("pg(%s): degenerate facet\n", stp->st_name);
 	return 0;			/* BAD */
@@ -463,7 +463,7 @@
     while (trip != TRI_NULL) {
 	struct tri_specific *nexttri = trip->tri_forw;
 
-	bu_free((char *)trip, "pg tri_specific");
+	bu_free((genptr_t)trip, "pg tri_specific");
 	trip = nexttri;
     }
 }
@@ -653,8 +653,8 @@
 	/* Associate face geometry */
 	if (nmg_calc_face_g(fu)) {
 	    nmg_pr_fu_briefly(fu, "");
-	    bu_free((char *)verts, "pg_tess verts[]");
-	    bu_free((char *)vertp, "pg_tess vertp[]");
+	    bu_free((genptr_t)verts, "pg_tess verts[]");
+	    bu_free((genptr_t)vertp, "pg_tess vertp[]");
 	    return -1;			/* FAIL */
 	}
     }
@@ -666,8 +666,8 @@
      * Don't depend on them here.
      */
     nmg_fix_normals(s, tol);
-    bu_free((char *)verts, "pg_tess verts[]");
-    bu_free((char *)vertp, "pg_tess vertp[]");
+    bu_free((genptr_t)verts, "pg_tess verts[]");
+    bu_free((genptr_t)vertp, "pg_tess vertp[]");
 
     return 0;		/* OK */
 }
@@ -923,14 +923,14 @@
      * Free storage for each polygon
      */
     for (i=0; i < pgp->npoly; i++) {
-	bu_free((char *)pgp->poly[i].verts, "pg verts[]");
-	bu_free((char *)pgp->poly[i].norms, "pg norms[]");
+	bu_free((genptr_t)pgp->poly[i].verts, "pg verts[]");
+	bu_free((genptr_t)pgp->poly[i].norms, "pg norms[]");
     }
     if (pgp->npoly)
-	bu_free((char *)pgp->poly, "pg poly[]");
+	bu_free((genptr_t)pgp->poly, "pg poly[]");
     pgp->magic = 0;			/* sanity */
     pgp->npoly = 0;
-    bu_free((char *)pgp, "pg ifree");
+    bu_free((genptr_t)pgp, "pg ifree");
     ip->idb_ptr = GENPTR_NULL;	/* sanity */
 }
 /**
Index: librt/primitives/poly/poly_mirror.c
===================================================================
--- librt/primitives/poly/poly_mirror.c	(revision 54048)
+++ librt/primitives/poly/poly_mirror.c	(working copy)
@@ -121,8 +121,8 @@
 	}
     }
 
-    bu_free((char *)verts, "rt_mirror: verts");
-    bu_free((char *)norms, "rt_mirror: norms");
+    bu_free((genptr_t)verts, "rt_mirror: verts");
+    bu_free((genptr_t)norms, "rt_mirror: norms");
 
     return 0;
 }
Index: librt/primitives/rpc/rpc.c
===================================================================
--- librt/primitives/rpc/rpc.c	(revision 54048)
+++ librt/primitives/rpc/rpc.c	(working copy)
@@ -644,7 +644,7 @@
     struct rpc_specific *rpc =
 	(struct rpc_specific *)stp->st_specific;
 
-    bu_free((char *)rpc, "rpc_specific");
+    bu_free((genptr_t)rpc, "rpc_specific");
 }
 
 
@@ -997,7 +997,7 @@
 	i += 3;
 	old = pos;
 	pos = pos->next;
-	bu_free((char *)old, "rt_pt_node");
+	bu_free((genptr_t)old, "rt_pt_node");
     }
 
     /* Draw the front */
@@ -1019,8 +1019,8 @@
 	RT_ADD_VLIST(vhead, &back[i*ELEMENTS_PER_VECT], BN_VLIST_LINE_DRAW);
     }
 
-    bu_free((char *)front, "fastf_t");
-    bu_free((char *)back,  "fastf_t");
+    bu_free((genptr_t)front, "fastf_t");
+    bu_free((genptr_t)back,  "fastf_t");
 
     return 0;
 }
@@ -1196,7 +1196,7 @@
 	j++;
 	old = pos;
 	pos = pos->next;
-	bu_free((char *)old, "rt_pt_node");
+	bu_free((genptr_t)old, "rt_pt_node");
     }
 
     *r = nmg_mrsv(m);	/* Make region, empty shell, vertex */
@@ -1253,8 +1253,8 @@
     for (i=0; i < n+2; i++) {
 	if (nmg_fu_planeeqn(outfaceuses[i], tol) < 0) {
 	    /* free mem */
-	    bu_free((char *)front, "fastf_t");
-	    bu_free((char *)back, "fastf_t");
+	    bu_free((genptr_t)front, "fastf_t");
+	    bu_free((genptr_t)back, "fastf_t");
 	    bu_free((char*)vfront, "vertex *");
 	    bu_free((char*)vback, "vertex *");
 	    bu_free((char*)vtemp, "vertex *");
@@ -1314,8 +1314,8 @@
     nmg_region_a(*r, tol);
 
     /* free mem */
-    bu_free((char *)front, "fastf_t");
-    bu_free((char *)back, "fastf_t");
+    bu_free((genptr_t)front, "fastf_t");
+    bu_free((genptr_t)back, "fastf_t");
     bu_free((char*)vfront, "vertex *");
     bu_free((char*)vback, "vertex *");
     bu_free((char*)vtemp, "vertex *");
@@ -1383,7 +1383,7 @@
 
     if (xip->rpc_r <= SMALL_FASTF) {
 	bu_log("rt_rpc_import4: r is zero\n");
-	bu_free((char *)ip->idb_ptr, "rt_rpc_import4: ip->idp_ptr");
+	bu_free((genptr_t)ip->idb_ptr, "rt_rpc_import4: ip->idp_ptr");
 	return -1;
     }
 
@@ -1482,7 +1482,7 @@
 
     if (xip->rpc_r <= SMALL_FASTF) {
 	bu_log("rt_rpc_import4: r is zero\n");
-	bu_free((char *)ip->idb_ptr, "rt_rpc_import4: ip->idp_ptr");
+	bu_free((genptr_t)ip->idb_ptr, "rt_rpc_import4: ip->idp_ptr");
 	return -1;
     }
 
@@ -1605,7 +1605,7 @@
     RT_RPC_CK_MAGIC(xip);
     xip->rpc_magic = 0;		/* sanity */
 
-    bu_free((char *)xip, "rpc ifree");
+    bu_free((genptr_t)xip, "rpc ifree");
     ip->idb_ptr = GENPTR_NULL;	/* sanity */
 }
 
Index: librt/primitives/ars/ars_mirror.c
===================================================================
--- librt/primitives/ars/ars_mirror.c	(revision 54048)
+++ librt/primitives/ars/ars_mirror.c	(working copy)
@@ -110,7 +110,7 @@
 	memcpy(ars->curves[i], tmp_curve, ars->pts_per_curve*3*sizeof(fastf_t));
     }
 
-    bu_free((char *)tmp_curve, "rt_mirror: tmp_curve");
+    bu_free((genptr_t)tmp_curve, "rt_mirror: tmp_curve");
 
     return 0;
 }
Index: librt/primitives/ars/ars.c
===================================================================
--- librt/primitives/ars/ars.c	(revision 54048)
+++ librt/primitives/ars/ars.c	(working copy)
@@ -479,12 +479,12 @@
      * Free storage for faces
      */
     for (i = 0; i < arip->ncurves; i++) {
-	bu_free((char *)arip->curves[i], "ars curve");
+	bu_free((genptr_t)arip->curves[i], "ars curve");
     }
-    bu_free((char *)arip->curves, "ars curve ptrs");
+    bu_free((genptr_t)arip->curves, "ars curve ptrs");
     arip->magic = 0;		/* sanity */
     arip->ncurves = 0;
-    bu_free((char *)arip, "ars ifree");
+    bu_free((genptr_t)arip, "ars ifree");
     ip->idb_ptr = GENPTR_NULL;	/* sanity */
 }
 
@@ -638,7 +638,7 @@
 	}
     }
 
-    bu_free((char *)verts, "rt_ars_tess *verts[]");
+    bu_free((genptr_t)verts, "rt_ars_tess *verts[]");
 
     /* kill any degenerate faces that may have been created */
     for (i=0; i<(size_t)BU_PTBL_END(&kill_fus); i++) {
@@ -1215,7 +1215,7 @@
 	    i = atoi(argv[1]);
 	    if (i < ars->ncurves) {
 		for (j=i; j<ars->ncurves; j++)
-		    bu_free((char *)ars->curves[j], "ars->curves[j]");
+		    bu_free((genptr_t)ars->curves[j], "ars->curves[j]");
 		ars->curves = (fastf_t **)bu_realloc(ars->curves,
 						     i*sizeof(fastf_t *), "ars->curves");
 		ars->ncurves = i;
Index: librt/primitives/ehy/ehy.c
===================================================================
--- librt/primitives/ehy/ehy.c	(revision 54048)
+++ librt/primitives/ehy/ehy.c	(working copy)
@@ -659,7 +659,7 @@
 	(struct ehy_specific *)stp->st_specific;
 
 
-    bu_free((char *)ehy, "ehy_specific");
+    bu_free((genptr_t)ehy, "ehy_specific");
 }
 
 
@@ -1050,7 +1050,7 @@
 
 	    /* get next node before freeing */
 	    next = pos_b->next;
-	    bu_free((char *)pos_b, "rt_pt_node");
+	    bu_free((genptr_t)pos_b, "rt_pt_node");
 	    pos_b = next;
 	}
 	/* construct hyperbola along semi-major axis of ehy using same
@@ -1172,10 +1172,10 @@
 
     /* free mem */
     for (i = 0; i < nell; i++) {
-	bu_free((char *)ellipses[i], "pts ell");
+	bu_free((genptr_t)ellipses[i], "pts ell");
     }
-    bu_free((char *)ellipses, "fastf_t ell[]");
-    bu_free((char *)pts_dbl, "dbl ints");
+    bu_free((genptr_t)ellipses, "fastf_t ell[]");
+    bu_free((genptr_t)pts_dbl, "dbl ints");
 
     return 0;
 }
@@ -1325,7 +1325,7 @@
 	    struct rt_pt_node *tmp;
 
 	    tmp = pos_b->next;
-	    bu_free((char *)pos_b, "rt_pt_node");
+	    bu_free((genptr_t)pos_b, "rt_pt_node");
 	    pos_b = tmp;
 	}
 	/* construct hyperbola along semi-major axis of ehy using same
@@ -1575,13 +1575,13 @@
     nmg_shell_coplanar_face_merge(s, tol, 1);
 
     /* free mem */
-    bu_free((char *)outfaceuses, "faceuse []");
+    bu_free((genptr_t)outfaceuses, "faceuse []");
     for (i = 0; i < nell; i++) {
-	bu_free((char *)ellipses[i], "pts ell");
-	bu_free((char *)vells[i], "vertex []");
+	bu_free((genptr_t)ellipses[i], "pts ell");
+	bu_free((genptr_t)vells[i], "vertex []");
     }
-    bu_free((char *)ellipses, "fastf_t ell[]");
-    bu_free((char *)vells, "vertex [][]");
+    bu_free((genptr_t)ellipses, "fastf_t ell[]");
+    bu_free((genptr_t)vells, "vertex [][]");
 
     /* Assign vertexuse normals */
     nmg_vertex_tabulate(&vert_tab, &s->l.magic);
@@ -1627,13 +1627,13 @@
 
  fail:
     /* free mem */
-    bu_free((char *)outfaceuses, "faceuse []");
+    bu_free((genptr_t)outfaceuses, "faceuse []");
     for (i = 0; i < nell; i++) {
-	bu_free((char *)ellipses[i], "pts ell");
-	bu_free((char *)vells[i], "vertex []");
+	bu_free((genptr_t)ellipses[i], "pts ell");
+	bu_free((genptr_t)vells[i], "vertex []");
     }
-    bu_free((char *)ellipses, "fastf_t ell[]");
-    bu_free((char *)vells, "vertex [][]");
+    bu_free((genptr_t)ellipses, "fastf_t ell[]");
+    bu_free((genptr_t)vells, "vertex [][]");
 
     return -1;
 }
@@ -1705,7 +1705,7 @@
 
     if (xip->ehy_r1 <= SMALL_FASTF || xip->ehy_r2 <= SMALL_FASTF || xip->ehy_c <= SMALL_FASTF) {
 	bu_log("rt_ehy_import4: r1, r2, or c are zero\n");
-	bu_free((char *)ip->idb_ptr, "rt_ehy_import4: ip->idb_ptr");
+	bu_free((genptr_t)ip->idb_ptr, "rt_ehy_import4: ip->idb_ptr");
 	return -1;
     }
 
@@ -1818,7 +1818,7 @@
 
     if (xip->ehy_r1 <= SMALL_FASTF || xip->ehy_r2 <= SMALL_FASTF || xip->ehy_c <= SMALL_FASTF) {
 	bu_log("rt_ehy_import5: r1, r2, or c are zero\n");
-	bu_free((char *)ip->idb_ptr, "rt_ehy_import5: ip->idb_ptr");
+	bu_free((genptr_t)ip->idb_ptr, "rt_ehy_import5: ip->idb_ptr");
 	return -1;
     }
 
@@ -1951,7 +1951,7 @@
     RT_EHY_CK_MAGIC(xip);
     xip->ehy_magic = 0;		/* sanity */
 
-    bu_free((char *)xip, "ehy ifree");
+    bu_free((genptr_t)xip, "ehy ifree");
     ip->idb_ptr = GENPTR_NULL;	/* sanity */
 }
 
Index: librt/primitives/eto/eto.c
===================================================================
--- librt/primitives/eto/eto.c	(revision 54048)
+++ librt/primitives/eto/eto.c	(working copy)
@@ -732,7 +732,7 @@
     struct eto_specific *eto =
 	(struct eto_specific *)stp->st_specific;
 
-    bu_free((char *)eto, "eto_specific");
+    bu_free((genptr_t)eto, "eto_specific");
 }
 
 
@@ -831,7 +831,7 @@
 	VMOVE(ell[i], pos->p);
 	oldpos = pos;
 	pos = pos->next;
-	bu_free((char *)oldpos, "rt_pt_node");
+	bu_free((genptr_t)oldpos, "rt_pt_node");
     }
     /* mirror 1st quad to make 2nd */
     for (i = (*n+1)+1; i < 2*(*n+1); i++) {
@@ -1131,7 +1131,7 @@
 	    RT_ADD_VLIST(vhead, ETO_PTA(j, i), BN_VLIST_LINE_DRAW);
     }
 
-    bu_free((char *)eto_ells, "ells[]");
+    bu_free((genptr_t)eto_ells, "ells[]");
     return 0;
 }
 
@@ -1306,11 +1306,11 @@
     nmg_region_a(*r, tol);
 
  failure:
-    bu_free((char *)ell, "make_ellipse pts");
-    bu_free((char *)eto_ells, "ells[]");
-    bu_free((char *)verts, "rt_eto_tess *verts[]");
-    bu_free((char *)faces, "rt_eto_tess *faces[]");
-    bu_free((char *)norms, "rt_eto_tess: norms[]");
+    bu_free((genptr_t)ell, "make_ellipse pts");
+    bu_free((genptr_t)eto_ells, "ells[]");
+    bu_free((genptr_t)verts, "rt_eto_tess *verts[]");
+    bu_free((genptr_t)faces, "rt_eto_tess *faces[]");
+    bu_free((genptr_t)norms, "rt_eto_tess: norms[]");
 
     return fail;
 }
@@ -1576,7 +1576,7 @@
     tip = (struct rt_eto_internal *)ip->idb_ptr;
     RT_ETO_CK_MAGIC(tip);
 
-    bu_free((char *)tip, "eto ifree");
+    bu_free((genptr_t)tip, "eto ifree");
     ip->idb_ptr = GENPTR_NULL;	/* sanity */
 }
 
Index: librt/primitives/sph/sph.c
===================================================================
--- librt/primitives/sph/sph.c	(revision 54048)
+++ librt/primitives/sph/sph.c	(working copy)
@@ -406,7 +406,7 @@
     register struct sph_specific *sph =
 	(struct sph_specific *)stp->st_specific;
 
-    bu_free((char *)sph, "sph_specific");
+    bu_free((genptr_t)sph, "sph_specific");
 }
 
 
Index: librt/primitives/cline/cline.c
===================================================================
--- librt/primitives/cline/cline.c	(revision 54048)
+++ librt/primitives/cline/cline.c	(working copy)
@@ -441,7 +441,7 @@
 
     if (stp) RT_CK_SOLTAB(stp);
 
-    bu_free((char *)cline, "cline_specific");
+    bu_free((genptr_t)cline, "cline_specific");
 }
 
 
@@ -791,11 +791,11 @@
 	}
     }
 
-    bu_free((char *)base_outer, "base outer vertices");
-    bu_free((char *)top_outer, "top outer vertices");
+    bu_free((genptr_t)base_outer, "base outer vertices");
+    bu_free((genptr_t)top_outer, "top outer vertices");
     if (cline_ip->thickness > 0.0 && cline_ip->thickness < cline_ip->radius) {
-	bu_free((char *)base_inner, "base inner vertices");
-	bu_free((char *)top_inner, "top inner vertices");
+	bu_free((genptr_t)base_inner, "base inner vertices");
+	bu_free((genptr_t)top_inner, "top inner vertices");
     }
 
     /* Associate face plane equations */
@@ -1043,7 +1043,7 @@
     RT_CLINE_CK_MAGIC(cline_ip);
     cline_ip->magic = 0;			/* sanity */
 
-    bu_free((char *)cline_ip, "cline ifree");
+    bu_free((genptr_t)cline_ip, "cline ifree");
     ip->idb_ptr = GENPTR_NULL;	/* sanity */
 }
 
Index: librt/primitives/superell/superell.c
===================================================================
--- librt/primitives/superell/superell.c	(revision 54048)
+++ librt/primitives/superell/superell.c	(working copy)
@@ -641,7 +641,7 @@
     struct superell_specific *superell =
 	(struct superell_specific *)stp->st_specific;
 
-    bu_free((char *)superell, "superell_specific");
+    bu_free((genptr_t)superell, "superell_specific");
 }
 
 
Index: librt/primitives/arb8/arb8.c
===================================================================
--- librt/primitives/arb8/arb8.c	(revision 54048)
+++ librt/primitives/arb8/arb8.c	(working copy)
@@ -1115,8 +1115,8 @@
 	(struct arb_specific *)stp->st_specific;
 
     if (arbp->arb_opt)
-	bu_free((char *)arbp->arb_opt, "arb_opt");
-    bu_free((char *)arbp, "arb_specific");
+	bu_free((genptr_t)arbp->arb_opt, "arb_opt");
+    bu_free((genptr_t)arbp, "arb_specific");
 }
 
 #define ARB_FACE(vlist_head, arb_pts, a, b, c, d) \
Index: librt/primitives/bspline/nurb_reverse.c
===================================================================
--- librt/primitives/bspline/nurb_reverse.c	(revision 54048)
+++ librt/primitives/bspline/nurb_reverse.c	(working copy)
@@ -79,7 +79,7 @@
     srf->u.knots = srf->v.knots;
     srf->v.knots = p_ptr;
 
-    bu_free((char *) tmp, "temporary storage for transpose");
+    bu_free((genptr_t) tmp, "temporary storage for transpose");
 }
 
 
Index: librt/primitives/bspline/nurb_knot.c
===================================================================
--- librt/primitives/bspline/nurb_knot.c	(revision 54048)
+++ librt/primitives/bspline/nurb_knot.c	(working copy)
@@ -108,7 +108,7 @@
     rt_nurb_kvmerge(new_kv, &check, kv, res);
 
     /* free up old knot values */
-    bu_free((char *)check.knots, "rt_nurb_kvmult:check knots");
+    bu_free((genptr_t)check.knots, "rt_nurb_kvmult:check knots");
 }
 
 
Index: librt/primitives/bspline/nurb_util.c
===================================================================
--- librt/primitives/bspline/nurb_util.c	(revision 54048)
+++ librt/primitives/bspline/nurb_util.c	(working copy)
@@ -113,9 +113,9 @@
 
     if (res) RT_CK_RESOURCE(res);
 
-    bu_free((char *)srf->u.knots, "rt_nurb_clean_snurb() u.knots");
-    bu_free((char *)srf->v.knots, "rt_nurb_free_snurb() v.knots");
-    bu_free((char *)srf->ctl_points, "rt_nurb_free_snurb() ctl_points");
+    bu_free((genptr_t)srf->u.knots, "rt_nurb_clean_snurb() u.knots");
+    bu_free((genptr_t)srf->v.knots, "rt_nurb_free_snurb() v.knots");
+    bu_free((genptr_t)srf->ctl_points, "rt_nurb_free_snurb() ctl_points");
 
     /* Invalidate the structure */
     srf->u.knots = (fastf_t *)NULL;
@@ -140,12 +140,12 @@
      * deleted.
      */
 
-    bu_free((char *)srf->u.knots, "rt_nurb_free_snurb: u kv knots");
-    bu_free((char *)srf->v.knots, "rt_nurb_free_snurb: v kv knots");
-    bu_free((char *)srf->ctl_points, "rt_nurb_free_snurb: mesh points");
+    bu_free((genptr_t)srf->u.knots, "rt_nurb_free_snurb: u kv knots");
+    bu_free((genptr_t)srf->v.knots, "rt_nurb_free_snurb: v kv knots");
+    bu_free((genptr_t)srf->ctl_points, "rt_nurb_free_snurb: mesh points");
 
     srf->l.magic = 0;
-    bu_free((char *)srf, "rt_nurb_free_snurb: snurb struct");
+    bu_free((genptr_t)srf, "rt_nurb_free_snurb: snurb struct");
 }
 
 
Index: librt/primitives/bspline/nurb_xsplit.c
===================================================================
--- librt/primitives/bspline/nurb_xsplit.c	(revision 54048)
+++ librt/primitives/bspline/nurb_xsplit.c	(working copy)
@@ -204,7 +204,7 @@
 
     BU_LIST_APPEND(&srf1->l, &srf2->l);
 
-    bu_free((char *) new_kv.knots, "rt_nurb_s_xsplit: new_kv.knots");
+    bu_free((genptr_t) new_kv.knots, "rt_nurb_s_xsplit: new_kv.knots");
 
     rt_nurb_free_oslo(oslo, (struct resource *)NULL);
 
@@ -271,7 +271,7 @@
 
     rt_nurb_free_oslo(oslo, (struct resource *)NULL);
 
-    bu_free((char *) new_kv.knots, "rt_nurb_c_xsplit: new_kv.knots");
+    bu_free((genptr_t) new_kv.knots, "rt_nurb_c_xsplit: new_kv.knots");
 
     BU_LIST_APPEND(&crv1->l, &crv2->l);
     return crv1;
Index: librt/primitives/bspline/nurb_flat.c
===================================================================
--- librt/primitives/bspline/nurb_flat.c	(revision 54048)
+++ librt/primitives/bspline/nurb_flat.c	(working copy)
@@ -90,7 +90,7 @@
 	max_row_dist = FMAX(max_row_dist, rdist);
     }
 
-    bu_free((char *)crv, "rt_nurb_s_flat: crv");
+    bu_free((genptr_t)crv, "rt_nurb_s_flat: crv");
 
     crv = (fastf_t *) bu_malloc(sizeof(fastf_t) *
 				RT_NURB_EXTRACT_COORDS(srf->pt_type) *
@@ -114,7 +114,7 @@
 	max_col_dist = FMAX(max_col_dist, rdist);
     }
 
-    bu_free((char *)crv, "rt_nurb_s_flat: crv");
+    bu_free((genptr_t)crv, "rt_nurb_s_flat: crv");
 
     max_dist = FMAX(max_row_dist, max_col_dist);
 
Index: librt/primitives/bspline/nurb_eval.c
===================================================================
--- librt/primitives/bspline/nurb_eval.c	(revision 54048)
+++ librt/primitives/bspline/nurb_eval.c	(working copy)
@@ -102,7 +102,7 @@
 	c_ptr += coords;
     }
 
-    bu_free((char *)curves, "rt_nurb_s_eval: curves");
+    bu_free((genptr_t)curves, "rt_nurb_s_eval: curves");
 
     k_index = rt_nurb_knot_index(&srf->v, v, srf->order[RT_NURB_SPLIT_COL]);
     if (k_index < 0) {
@@ -154,7 +154,7 @@
     for (i = 0; i < coords; i++)
 	final_value[i] = ev_pt[i];
 
-    bu_free((char *) pnts, "rt_nurb_c_eval");
+    bu_free((genptr_t) pnts, "rt_nurb_c_eval");
 }
 
 
Index: librt/primitives/bspline/nurb_solve.c
===================================================================
--- librt/primitives/bspline/nurb_solve.c	(revision 54048)
+++ librt/primitives/bspline/nurb_solve.c	(working copy)
@@ -198,9 +198,9 @@
 	}
 
     }
-    bu_free((char *)d, "rt_nurb_doolittle:d");		/* Free up the storage. */
-    bu_free((char *)s, "rt_nurb_doolittle:s");
-    bu_free((char *)ds, "rt_nurb_doolittle:ds");
+    bu_free((genptr_t)d, "rt_nurb_doolittle:d");		/* Free up the storage. */
+    bu_free((genptr_t)s, "rt_nurb_doolittle:s");
+    bu_free((genptr_t)ds, "rt_nurb_doolittle:ds");
 }
 
 
Index: librt/primitives/bspline/nurb_split.c
===================================================================
--- librt/primitives/bspline/nurb_split.c	(revision 54048)
+++ librt/primitives/bspline/nurb_split.c	(working copy)
@@ -235,7 +235,7 @@
     BU_LIST_APPEND(split_hd, &srf1->l);
 
     rt_nurb_free_oslo(oslo, res);
-    bu_free((char *)new_kv.knots, "rt_nurb_s_split: new kv knots");
+    bu_free((genptr_t)new_kv.knots, "rt_nurb_s_split: new kv knots");
 
 }
 
@@ -320,7 +320,7 @@
 
     rt_nurb_free_oslo(oslo, (struct resource *)NULL);
 
-    bu_free((char *) new_kv.knots, "rt_nurb_c_split; new_kv.knots");
+    bu_free((genptr_t) new_kv.knots, "rt_nurb_c_split; new_kv.knots");
 
     /* Arrangement will be:  head, crv1, crv2 */
     BU_LIST_APPEND(split_hd, &crv2->l);
Index: librt/primitives/bspline/bspline_mirror.c
===================================================================
--- librt/primitives/bspline/bspline_mirror.c	(revision 54048)
+++ librt/primitives/bspline/bspline_mirror.c	(working copy)
@@ -137,7 +137,7 @@
 	}
 
 	/* free old mesh */
-	bu_free((char *)nurb->srfs[i]->ctl_points, "rt_mirror: ctl points");
+	bu_free((genptr_t)nurb->srfs[i]->ctl_points, "rt_mirror: ctl points");
 
 	/* put new mesh in place */
 	nurb->srfs[i]->ctl_points = ptr;
